## cctools 7.0.9

=== Makefile ===
include config.mk
include rules.mk

CYGWINLIB = cygwin1.dll cyggcc_s-1.dll cygintl-8.dll cygreadline7.dll cygncursesw-10.dll cygiconv-2.dll cygattr-1.dll sh.exe

#set the default values for RPM_VERSION and RPM_RELEASE
RPM_VERSION=4.4.1
RPM_RELEASE=1

all: $(CCTOOLS_PACKAGES)

config.mk:
	@echo "You must run 'configure' before '${MAKE}'."
	@exit 1

makeflow wavefront: batch_job
batch_job parrot: chirp
allpairs batch_job chirp deltadb ftp_lite makeflow makeflow_linker parrot resource_monitor sand wavefront work_queue grow: dttools
parrot: ftp_lite grow
allpairs: sand
allpairs batch_job makeflow sand wavefront: work_queue

$(CCTOOLS_PACKAGES): config.mk
	@$(MAKE) -C $@

CLEAN_PACKAGES = $(CCTOOLS_PACKAGES:%=clean-%)
$(CLEAN_PACKAGES):
	@$(MAKE) -C $(@:clean-%=%) clean
clean: $(CLEAN_PACKAGES)

INSTALL_PACKAGES = $(CCTOOLS_PACKAGES:%=install-%)
$(INSTALL_PACKAGES): $(CCTOOLS_PACKAGES)
	@$(MAKE) -C $(@:install-%=%) install
install: $(INSTALL_PACKAGES)
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	for file in $(CYGWINLIB) ; do if [ -f /bin/$$file ] ; then cp /bin/$$file $(CCTOOLS_INSTALL_DIR)/bin/ ; fi ; done
	mkdir -p ${CCTOOLS_INSTALL_DIR}/etc
	cp config.mk ${CCTOOLS_INSTALL_DIR}/etc/
	mkdir -p ${CCTOOLS_INSTALL_DIR}/doc
	cp COPYING ${CCTOOLS_INSTALL_DIR}/doc/
	cp README ${CCTOOLS_INSTALL_DIR}/doc/

test: $(CCTOOLS_PACKAGES)
	./run_all_tests.sh

rpm:
	./packaging/rpm/rpm_creator.sh $(RPM_VERSION) $(RPM_RELEASE)

.PHONY: $(CCTOOLS_PACKAGES) $(INSTALL_PACKAGES) $(CLEAN_PACKAGES) all clean install test rpm

=== apps/wq_sort/Makefile ===
CCTOOLS_HOME = ../../

include ${CCTOOLS_HOME}/config.mk
include ${CCTOOLS_HOME}/rules.mk

PROGRAMS = wq_sort

LOCAL_LDFLAGS= -lwork_queue -ldttools ${CCTOOLS_INTERNAL_LDFLAGS}

all: ${PROGRAMS}

wq_sort: wq_sort.o
	${CCTOOLS_LD} wq_sort.o ${LOCAL_LDFLAGS} -o $@

clean:
	rm -f *~ *.o ${PROGRAMS}

test: all

install: all
	mkdir -p ${CCTOOLS_INSTALL_DIR}/bin
	cp ${PROGRAMS} ${CCTOOLS_INSTALL_DIR}/bin

=== chirp/src/Makefile ===
include ../../config.mk
include ../../rules.mk

# -DSQLITE_DEFAULT_MMAP_SIZE=1073741824 - allow mmap of database.
# -DSQLITE_TEMP_STORE=3 - only use memory for temporary files.
# -DSQLITE_THREADSAFE=0 - we only use sqlite3 multi-process (i.e. no threads). This disables somewhat costly mutex locks.
LOCAL_CCFLAGS = -DSQLITE_DEFAULT_MMAP_SIZE=1073741824 -DSQLITE_TEMP_STORE=3 -DSQLITE_THREADSAFE=0 -fstack-protector-all

# Globus is needed by all executables via libdttools.a/auth_globus.o
LOCAL_LINKAGE = $(CCTOOLS_GLOBUS_LDFLAGS)

EXTERNAL_DEPENDENCIES = ../../dttools/src/libdttools.a
LIBRARIES = libchirp.a libconfuga.a
OBJECTS = chirp_tool.o chirp_fuse.o $(OBJECTS_CONFUGA) $(OBJECTS_LIBRARY) $(OBJECTS_SERVER)
OBJECTS_CONFUGA = $(SOURCES_CONFUGA:%.c=%.o)
OBJECTS_LIBRARY = $(SOURCES_LIBRARY:%.c=%.o)
OBJECTS_SERVER = $(SOURCES_SERVER:%.c=%.o)
PROGRAMS = $(PROGRAMS_CHIRP) $(PROGRAMS_CONFUGA)
PROGRAMS_CHIRP = chirp chirp_get chirp_put chirp_server chirp_status chirp_benchmark chirp_stream_files chirp_fuse chirp_distribute
PROGRAMS_CONFUGA = confuga_adm
PUBLIC_HEADERS = chirp_global.h chirp_multi.h chirp_reli.h chirp_client.h chirp_stream.h chirp_protocol.h chirp_matrix.h chirp_types.h chirp_recursive.h confuga.h
SCRIPTS = chirp_audit_cluster chirp_server_hdfs
SOURCES_CONFUGA = confuga.c confuga_namespace.c confuga_replica.c confuga_node.c confuga_job.c confuga_file.c confuga_gc.c
SOURCES_LIBRARY = chirp_global.c chirp_multi.c chirp_recursive.c chirp_reli.c chirp_client.c chirp_matrix.c chirp_stream.c chirp_ticket.c
SOURCES_SERVER = sqlite3.c chirp_stats.c chirp_thirdput.c chirp_alloc.c chirp_audit.c chirp_acl.c chirp_group.c chirp_filesystem.c chirp_fs_hdfs.c chirp_fs_local.c chirp_fs_local_scheduler.c chirp_fs_chirp.c chirp_fs_confuga.c chirp_job.c chirp_sqlite.c
TARGETS = $(PROGRAMS) $(LIBRARIES) bindings

all: $(TARGETS)

chirp: chirp_tool.o
ifeq ($(CCTOOLS_STATIC),1)
	$(CCTOOLS_LD) -static -g -o $@ $(LOCAL_LINKAGE) $^ $(CCTOOLS_STATIC_LINKAGE)
else
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_READLINE_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE) $(CCTOOLS_READLINE_LDFLAGS)
endif

ifeq ($(CCTOOLS_STATIC),1)
chirp_fuse:
	@echo "chirp_fuse cannot be built statically"
else
chirp_fuse: chirp_fuse.o
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_FUSE_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE)

chirp_fuse.o: chirp_fuse.c
	$(CCTOOLS_CC) -o $@ -c $(CCTOOLS_INTERNAL_CCFLAGS) $(LOCAL_CCFLAGS) $(CCTOOLS_FUSE_CCFLAGS) $<
endif

chirp_job.o chirp_fs_local_scheduler.o: chirp_sqlite.h

# This is the library intended to be used by clients of the system.
libchirp.a: $(OBJECTS_LIBRARY)

confuga.o confuga_job.o confuga_namespace.o confuga_node.o confuga_replica.o confuga_file.o: confuga.h confuga_fs.h chirp_sqlite.h
libconfuga.a: $(OBJECTS_CONFUGA) $(OBJECTS_LIBRARY) chirp_sqlite.o sqlite3.o
libconfuga.$(CCTOOLS_DYNAMIC_SUFFIX): $(OBJECTS_CONFUGA) ../../dttools/src/auth_all.o $(EXTERNAL_DEPENDENCIES)

chirp_server: $(OBJECTS_SERVER) libconfuga.a
$(PROGRAMS_CONFUGA): libconfuga.a libchirp.a $(EXTERNAL_DEPENDENCIES)
$(PROGRAMS_CHIRP): libchirp.a $(EXTERNAL_DEPENDENCIES)
$(CCTOOLS_SWIG_BINDINGS): libchirp.a $(EXTERNAL_DEPENDENCIES)

bindings: $(CCTOOLS_SWIG_BINDINGS)
$(CCTOOLS_SWIG_BINDINGS): chirp_swig_wrap.o
	@$(MAKE) -C $@

CCTOOLS_SWIG_BINDINGS_INSTALL = $(CCTOOLS_SWIG_BINDINGS:%=install-%)
install-bindings: $(CCTOOLS_SWIG_BINDINGS_INSTALL)
$(CCTOOLS_SWIG_BINDINGS_INSTALL): $(CCTOOLS_SWIG_BINDINGS)
	@$(MAKE) -C $(@:install-%=%) install

CCTOOLS_SWIG_BINDINGS_CLEAN = $(CCTOOLS_SWIG_BINDINGS:%=clean-%)
clean-bindings: $(CCTOOLS_SWIG_BINDINGS_CLEAN)
$(CCTOOLS_SWIG_BINDINGS_CLEAN):
	@$(MAKE) -C $(@:clean-%=%) clean

clean: clean-bindings
	rm -f $(OBJECTS) $(TARGETS)

install: all install-bindings
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	if [ -f $(CCTOOLS_INSTALL_DIR)/bin/chirp_server ]; then mv $(CCTOOLS_INSTALL_DIR)/bin/chirp_server $(CCTOOLS_INSTALL_DIR)/bin/chirp_server.old; fi
	chmod 755 $(SCRIPTS)
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(PUBLIC_HEADERS) $(CCTOOLS_INSTALL_DIR)/include/cctools/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/share/cctools/chirp/
	cp -r ../tools/workflows/ $(CCTOOLS_INSTALL_DIR)/share/cctools/chirp/

test: all

.PHONY: all clean install test $(CCTOOLS_SWIG_BINDINGS) bindings $(CCTOOLS_SWIG_BINDINGS_INSTALL) install-bindings $(CCTOOLS_SWIG_BINDINGS_CLEAN) clean-bindings

=== deltadb/src/Makefile ===
include ../../config.mk
include ../../rules.mk

EXTERNAL_DEPENDENCIES = ../../dttools/src/libdttools.a
LIBRARIES = libdeltadb.a
OBJECTS = $(SOURCES:%.c=%.o)
PROGRAMS = deltadb_query
SCRIPTS =
SOURCES = deltadb_stream.c deltadb_reduction.c
TARGETS = $(LIBRARIES) $(PROGRAMS)

all: $(TARGETS)

libdeltadb.a: $(OBJECTS)

$(PROGRAMS): $(LIBRARIES) $(EXTERNAL_DEPENDENCIES)

clean:
	rm -f $(OBJECTS) $(TARGETS)

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin

test: all

.PHONY: all clean install test

=== dttools/src/Makefile ===
include ../../config.mk
include ../../rules.mk

SOURCES = \
	address.c \
	auth.c \
	auth_address.c \
	auth_all.c \
	auth_globus.c \
	auth_hostname.c \
	auth_kerberos.c \
	auth_ticket.c \
	auth_unix.c \
	b64.c \
	bitmap.c \
	buffer.c \
	catalog_query.c \
	category.c \
	cctools.c \
	change_process_title.c \
	chunk.c \
	clean_dir.c \
	compat-at.c \
	console_login.c \
	copy_stream.c \
	copy_tree.c \
	create_dir.c \
	daemon.c \
	datagram.c \
	debug.c \
	debug_file.c \
	debug_journal.c \
	debug_stream.c \
	debug_syslog.c \
	disk_alloc.c \
	domain_name.c \
	domain_name_cache.c \
	dpopen.c \
	elfheader.c \
	envtools.c \
	fast_popen.c \
	fd.c \
	file_cache.c \
	full_io.c \
	get_canonical_path.c \
	get_line.c \
	getopt.c \
	getopt_aux.c \
	gpu_info.c \
	hash_cache.c \
	hash_table.c \
	hdfs_library.c \
	histogram.c \
	hmac.c \
	host_disk_info.c \
	host_memory_info.c \
	http_query.c \
	interfaces_address.c \
	itable.c \
	json.c \
	json_aux.c \
	jx.c \
	jx_database.c \
	jx_getopt.c \
	jx_match.c \
	jx_parse.c \
	jx_print.c \
	jx_pretty_print.c \
	jx_table.c \
	jx_export.c \
	jx_eval.c \
	jx_function.c \
	link.c \
	link_auth.c \
	list.c \
	load_average.c \
	md5.c \
	memfdexe.c \
	mkdir_recursive.c \
	twister.c \
	nvpair.c \
	nvpair_jx.c \
	password_cache.c \
	path.c \
	path_disk_size_info.c \
	pattern.c \
	preadwrite.c \
	process.c \
	random.c \
	rmonitor.c \
	rmonitor_poll.c \
	rmsummary.c \
	set.c \
    semaphore.c \
	sha1.c \
	shell.c \
	sh_popen.c\
	sigdef.c \
	sleeptools.c \
	sort_dir.c \
	stats.c \
	string_array.c \
	stringtools.c \
	string_set.c \
	text_array.c \
	text_list.c \
	timer.c \
	timestamp.c \
	unlink_recursive.c \
	uptime.c \
	url_encode.c \
	username.c \
	uuid.c \
	xxmalloc.c

HEADERS_PUBLIC = \
	auth.h \
	auth_address.h \
	auth_all.h \
	auth_globus.h \
	auth_hostname.h \
	auth_kerberos.h \
	auth_ticket.h \
	auth_unix.h \
	buffer.h \
	category.h \
	copy_tree.h \
	debug.h \
	hash_table.h \
	histogram.h \
	http_query.h \
	int_sizes.h \
	jx.h \
	jx_match.h \
	link.h \
	md5.h \
	rmonitor_poll.h \
	rmsummary.h \
	timestamp.h

LIBRARIES = libdttools.a
PRELOAD_LIBRARIES = libforce_halt_enospc.so
OBJECTS = $(SOURCES:%.c=%.o)

#separate, because catalog_query has a slightly different order of linking.
MOST_PROGRAMS = catalog_update catalog_server watchdog disk_allocator jx2json jx2env
PROGRAMS = $(MOST_PROGRAMS) catalog_query

SCRIPTS = cctools_gpu_autodetect cctools_python
TARGETS = $(LIBRARIES) $(PRELOAD_LIBRARIES) $(PROGRAMS) $(TEST_PROGRAMS)
TEST_PROGRAMS = auth_test disk_alloc_test jx_test microbench multirun jx_count_obj_test histogram_test category_test

all: $(TARGETS) catalog_query

libdttools.a: $(OBJECTS)

$(MOST_PROGRAMS) $(TEST_PROGRAMS): libdttools.a

catalog_query: catalog_query.o catalog_query_tool.o libdttools.a

auth_globus.o: auth_globus.c
	$(CCTOOLS_CC) -o $@ -c $(CCTOOLS_INTERNAL_CCFLAGS) $(LOCAL_CCFLAGS) $(CCTOOLS_GLOBUS_CCFLAGS) $<

auth_test: auth_test.o libdttools.a
ifeq ($(CCTOOLS_STATIC),1)
	@echo "auth_test currently cannot be build statically."
else
	$(CCTOOLS_LD) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_GLOBUS_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE)
endif

libforce_halt_enospc.so: libforce_halt_enospc.o
	$(CCTOOLS_CC) -shared -fPIC $^ -o $@ -ldl

clean:
	rm -f $(OBJECTS) $(TARGETS) *.o

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(SCRIPTS) $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(PRELOAD_LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(HEADERS_PUBLIC) $(CCTOOLS_INSTALL_DIR)/include/cctools/

test: all

.PHONY: all clean install test

# vim: set noexpandtab tabstop=4:

=== ftsh/src/Makefile ===
include ../../config.mk
include ../../rules.mk

EXTERNAL_DEPENDENCIES = ../../dttools/src/libdttools.a
LIBRARIES = libftsh.a
OBJECTS = $(SOURCES:%.c=%.o)
PROGRAMS = ftsh
SOURCES = ast.c ast_execute.c ast_print.c buffer.c builtin.c cancel.c expr.c ftsh.c ftsh_error.c multi_fork.c parser.tab.c scanner.c timed_exec.c variable.c
TARGETS = $(PROGRAMS) $(LIBRARIES)

all: $(TARGETS)

libftsh.a: $(OBJECTS)
$(PROGRAMS): libftsh.a

parser.tab.c parser.tab.h: parser.y
	bison -d parser.y

scanner.c: scanner.l parser.tab.h
	flex -t scanner.l > scanner.c

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin/

clean:
	rm -f $(OBJECTS) $(TARGETS) parser.tab.c parser.tab.h scanner.c

test: all

.PHONY: all clean install test

=== resource_monitor/src/Makefile ===
UNAME := $(shell uname)

include ../../config.mk
include ../../rules.mk

LIBRARIES = librmonitor_helper.$(CCTOOLS_DYNAMIC_SUFFIX)
OBJECTS = resource_monitor_pb.o rmonitor_helper_comm.o resource_monitor.o resource_monitor_tools.o rmonitor_helper.o rmonitor_file_watch.o

LOCAL_LINKAGE = ../../dttools/src/libdttools.a

PROGRAMS = resource_monitor piggybacker rmonitor_poll_example rmonitor_snapshot

ifneq ($(CCTOOLS_STATIC),1)
PROGRAMS += resource_monitor_histograms
endif

# currently only python bindings have been implemented
CCTOOLS_SWIG_BINDINGS := $(filter python, $(CCTOOLS_SWIG_BINDINGS))

TARGETS = $(LIBRARIES) $(PROGRAMS)

all: $(TARGETS) bindings

# Note below: we use gcc on static builds so that the library gets to use the system linker.
librmonitor_helper.$(CCTOOLS_DYNAMIC_SUFFIX): rmonitor_helper.o rmonitor_helper_comm.o
ifeq ($(CCTOOLS_STATIC),1)
	gcc           -shared -Wl,-init,rmonitor_helper_initialize -fPIC $^ -o $@ -ldl $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LINKAGE) $(CCTOOLS_EXTERNAL_LINKAGE)
else
	$(CCTOOLS_CC) -shared -Wl,-init,rmonitor_helper_initialize -fPIC $^ -o $@ -ldl $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LINKAGE) $(CCTOOLS_EXTERNAL_LINKAGE)
endif

piggybacker: piggybacker.o

rmonitor_piggyback.h: librmonitor_helper.$(CCTOOLS_DYNAMIC_SUFFIX) piggybacker
	./piggybacker rmonitor_piggyback.h librmonitor_helper.$(CCTOOLS_DYNAMIC_SUFFIX)

resource_monitor_histograms: resource_monitor_histograms.o resource_monitor_tools.o
ifeq ($(CCTOOLS_STATIC),1)
	@echo "resource_monitor_histograms cannot be built statically"
else
	$(CCTOOLS_LD) -O3 -fopenmp -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LDFLAGS) $^ $(LOCAL_LINKAGE) $(CCTOOLS_EXTERNAL_LINKAGE)
endif

resource_monitor.o: resource_monitor.c rmonitor_piggyback.h

resource_monitor: resource_monitor.o rmonitor_helper_comm.o rmonitor_file_watch.o

rmonitor_snapshot: rmonitor_snapshot.o rmonitor_helper_comm.o

rmonitor_poll_example: rmonitor_poll_example.o

.PHONY: $(CCTOOLS_SWIG_BINDINGS)
bindings: $(CCTOOLS_SWIG_BINDINGS)
$(CCTOOLS_SWIG_BINDINGS):
	@$(MAKE) -C $@

CCTOOLS_SWIG_BINDINGS_INSTALL = $(CCTOOLS_SWIG_BINDINGS:%=install-%)
install-bindings: $(CCTOOLS_SWIG_BINDINGS_INSTALL)
$(CCTOOLS_SWIG_BINDINGS_INSTALL): $(CCTOOLS_SWIG_BINDINGS)
	@$(MAKE) -C $(@:install-%=%) install

CCTOOLS_SWIG_BINDINGS_CLEAN = $(CCTOOLS_SWIG_BINDINGS:%=clean-%)
clean-bindings: $(CCTOOLS_SWIG_BINDINGS_CLEAN)
$(CCTOOLS_SWIG_BINDINGS_CLEAN):
	@$(MAKE) -C $(@:clean-%=%) clean

clean: clean-bindings
	rm -f $(OBJECTS) $(TARGETS) $(PROGRAMS) resource_monitor_pb.* rmonitor_piggyback.h* *.o

install: all install-bindings
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/

test: all

.PHONY: all clean install test

=== work_queue/src/Makefile ===
include ../../config.mk
include ../../rules.mk

# Note that this list of sources only contains
# the items that go into libwork_queue.a, to
# avoid polluting user programs with our internal code.

SOURCES_LIBRARY = \
	work_queue.c \
	work_queue_catalog.c \
	work_queue_resources.c

SOURCES_WORKER = \
	work_queue_process.o \
	work_queue_watcher.o

PUBLIC_HEADERS = work_queue.h

LIBDTTOOLS = ${CCTOOLS_HOME}/dttools/src/libdttools.a
EXTERNALS = $(LIBDTTOOLS)
EXTERNAL_DEPENDENCIES = ../../dttools/src/libdttools.a
LIBRARIES = libwork_queue.a
OBJECTS = $(OBJECTS_LIBRARY) $(OBJECTS_WORKER) work_queue_test_main.o
OBJECTS_LIBRARY = $(SOURCES_LIBRARY:%.c=%.o)
OBJECTS_WORKER = $(SOURCES_WORKER:%.c=%.o)
PROGRAMS = work_queue_worker work_queue_status work_queue_example
PUBLIC_HEADERS = work_queue.h
SCRIPTS = work_queue_submit_common condor_submit_workers sge_submit_workers torque_submit_workers pbs_submit_workers slurm_submit_workers work_queue_graph_log
TEST_PROGRAMS = work_queue_example work_queue_test work_queue_test_watch work_queue_priority_test
TARGETS = $(LIBRARIES) $(PROGRAMS) $(TEST_PROGRAMS) sge_submit_workers bindings

all: $(TARGETS)

libwork_queue.a: $(OBJECTS_LIBRARY)
work_queue_test work_queue_test_watch: work_queue_test_main.o
work_queue_worker: $(OBJECTS_WORKER)
$(PROGRAMS) $(TEST_PROGRAMS) $(CCTOOLS_SWIG_BINDINGS): libwork_queue.a $(EXTERNAL_DEPENDENCIES)

bindings: $(CCTOOLS_SWIG_BINDINGS)
$(CCTOOLS_SWIG_BINDINGS): libwork_queue.a work_queue.i
	@$(MAKE) -C $@

CCTOOLS_SWIG_BINDINGS_INSTALL = $(CCTOOLS_SWIG_BINDINGS:%=install-%)
install-bindings: $(CCTOOLS_SWIG_BINDINGS_INSTALL)
$(CCTOOLS_SWIG_BINDINGS_INSTALL): $(CCTOOLS_SWIG_BINDINGS)
	@$(MAKE) -C $(@:install-%=%) install

CCTOOLS_SWIG_BINDINGS_CLEAN = $(CCTOOLS_SWIG_BINDINGS:%=clean-%)
clean-bindings: $(CCTOOLS_SWIG_BINDINGS_CLEAN)
$(CCTOOLS_SWIG_BINDINGS_CLEAN):
	@$(MAKE) -C $(@:clean-%=%) clean

sge_submit_workers: sge_submit_workers_common
	sed -e "s/SGE_CUSTOM_PARAMETERS/${CCTOOLS_SGE_PARAMETERS}/" $< > $@
	chmod 755 $@

install: all install-bindings
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	chmod 755 $(SCRIPTS)
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc
	cp work_queue_example.c $(CCTOOLS_INSTALL_DIR)/doc/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(PUBLIC_HEADERS) $(CCTOOLS_INSTALL_DIR)/include/cctools/

clean: clean-bindings
	rm -rf $(OBJECTS) $(LIBRARIES) $(PROGRAMS) $(TEST_PROGRAMS) *.o sge_submit_workers

test: all

.PHONY: all clean install test $(CCTOOLS_SWIG_BINDINGS) bindings $(CCTOOLS_SWIG_BINDINGS_INSTALL) install-bindings $(CCTOOLS_SWIG_BINDINGS_CLEAN) clean-bindings

=== chirp/src/python3/Makefile ===
all:
install:
clean:

=== work_queue/src/python/Makefile ===
include ../../../config.mk
include ../../../rules.mk

# Python always uses 'so' for its modules (even on Darwin)
CCTOOLS_DYNAMIC_SUFFIX = so
# SWIG produces code that causes a lot of warnings, so use -w to turn those off.
LOCAL_CCFLAGS = -fPIC -w $(CCTOOLS_PYTHON_CCFLAGS)
LOCAL_LINKAGE = $(CCTOOLS_PYTHON_LDFLAGS) -lz

EXTERNAL_DEPENDENCIES = ../libwork_queue.a ../../../dttools/src/libdttools.a
WQPYTHONSO = _work_queue.$(CCTOOLS_DYNAMIC_SUFFIX)
LIBRARIES = $(WQPYTHONSO)
OBJECTS = work_queue_wrap.o
TARGETS = $(LIBRARIES)

all: $(TARGETS)

# The odd symlink in the following rule is necessary to overcome a problem
# in the framework search path emitted by the Python configuration on macOS.
work_queue_wrap.c work_queue.py: work_queue.i work_queue.binding.py
	@echo "SWIG work_queue.i (python)"
	@$(CCTOOLS_SWIG) -o work_queue_wrap.c -python -I../../../dttools/src/ -I../ work_queue.i
	@cat work_queue.binding.py >> work_queue.py
	ln -sf /System/Library/Frameworks/Python.framework .

$(WQPYTHONSO): work_queue_wrap.o $(EXTERNAL_DEPENDENCIES)

clean:
	rm -f $(OBJECTS) $(TARGETS) Python.framework work_queue.py work_queue_wrap.c *.pyc

test:

install: all
	mkdir -p $(CCTOOLS_PYTHON_PATH)
	chmod 755 work_queue_example.py
	cp work_queue.py $(WQPYTHONSO) $(CCTOOLS_PYTHON_PATH)/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc
	cp work_queue_example.py $(CCTOOLS_INSTALL_DIR)/doc/

=== work_queue/src/python3/Makefile ===
include ../../../config.mk
include ../../../rules.mk

# Python always uses 'so' for its modules (even on Darwin)
CCTOOLS_DYNAMIC_SUFFIX = so
# SWIG produces code that causes a lot of warnings, so use -w to turn those off.
LOCAL_CCFLAGS = -w -fPIC $(CCTOOLS_PYTHON3_CCFLAGS)
LOCAL_LINKAGE = $(CCTOOLS_PYTHON3_LDFLAGS)

EXTERNAL_DEPENDENCIES = ../libwork_queue.a ../../../dttools/src/libdttools.a
WQPYTHONSO = _work_queue.$(CCTOOLS_DYNAMIC_SUFFIX)
LIBRARIES = $(WQPYTHONSO)
OBJECTS = work_queue_wrap.o
TARGETS = $(LIBRARIES) work_queue_example.py3

all: $(TARGETS)

# The odd symlink in the following rule is necessary to overcome a problem
# in the framework search path emitted by the Python configuration on macOS.
work_queue_wrap.c work_queue.py: work_queue.i work_queue.binding.py3
	@echo "SWIG work_queue.i (python)"
	@$(CCTOOLS_SWIG) -o work_queue_wrap.c -python -py3 -I../../../dttools/src -I../ work_queue.i
	@cat work_queue.binding.py3 >> work_queue.py
	ln -sf /System/Library/Frameworks/Python.framework .

$(WQPYTHONSO): work_queue_wrap.o $(EXTERNAL_DEPENDENCIES)

%.py3: %.py
	cp $< $@
	chmod 755 $@
	$(CCTOOLS_PYTHON3_2TO3) -w $@

work_queue.binding.py3: work_queue.binding.py
work_queue_example.py3: work_queue_example.py

test:

clean:
	rm -f $(OBJECTS) $(TARGETS) Python.framework work_queue.binding.py3* work_queue.py work_queue_wrap.c *.pyc work_queue_example.py3*

install: all
	mkdir -p $(CCTOOLS_PYTHON3_PATH)
	cp work_queue.py _work_queue.$(CCTOOLS_DYNAMIC_SUFFIX) $(CCTOOLS_PYTHON3_PATH)/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc
	cp work_queue_example.py3 $(CCTOOLS_INSTALL_DIR)/doc/

=== debian/changelog ===
cctools (7.0.9-5) unstable; urgency=medium

  * Add dh-python to Build-Depends for --with python3.
  * Drop ${python3:Depends} in d/control for main package in favour of 
    python3 as dh_python3 incorrectly includes python2 depends 
  * Convert scripts to python3. Closes: #936277
  * Ack old bug fixed in previous release: Closes: #755181

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 17 Nov 2019 08:45:05 +0000

cctools (7.0.9-4) unstable; urgency=medium

  * Change python3.7-examples to python3.8-examples: transition
  * Standards-Version: 4.4.1.0

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 27 Oct 2019 10:17:43 +0000

cctools (7.0.9-3) unstable; urgency=medium

  * Move to debhelper-compat 12
  * Drop python-workqueue for python2 transition. Closes: #936277
  * Standards-Version: 4.4.0
  * Use python3.7-examples for 2to3 script

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 01 Oct 2019 21:16:49 +0100

cctools (7.0.9-2) unstable; urgency=medium

  * sysmacro.patch: Ensure major/minor macros present on i386. Closes: #917626
  * Standards-Version: 4.3.0

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 01 Jan 2019 12:15:16 +0000

cctools (7.0.9-1) unstable; urgency=medium

  * New upstream release, closes: #917626
  * Drop hard-coded xz compression
  * Standards-Version: 4.2.1
  * Set BUILD_* in configure for reproducible builds

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 31 Dec 2018 07:21:13 +0000

=== debian/control ===
Source: cctools
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 12), 
  dh-python,
  python3-all-dev, 
  python3.8-examples,
  libglobus-common-dev,
  default-libmysqlclient-dev,
  libfuse-dev,
  libperl-dev,
  libkrb5-dev,
  libsqlite3-dev,
  pkg-config,
  libglobus-gss-assist-dev, net-tools, doxygen,
  libreadline6-dev | libreadline-dev, 
  libncurses5-dev | libncurses-dev, 
  swig,
  m4, 
  mpi-default-dev
Standards-Version: 4.4.1.0
Homepage: https://ccl.cse.nd.edu/software/
Vcs-Browser: https://salsa.debian.org:/neurodebian-team/cctools.git
Vcs-Git: https://salsa.debian.org:/neurodebian-team/cctools.git

Package: coop-computing-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Suggests: coop-computing-tools-doc, condor, gridengine-client
Description: cooperative computing tools
 This is a collection of software that help users to share resources in a
 complex, heterogeneous, and unreliable computing environment. This includes:
 .
  * Chirp: A personal filesystem and I/O protocol that allows unprivileged users
    to share space securely, efficiently, and conveniently. When combined
    with Parrot, Chirp allows users to create custom wide-area
    distributed filesystems.
  * Parrot: A transparent user-level virtual filesystem that allows any ordinary
    program to be attached to a remote storage device such as an FTP
    server or a Chirp server.
  * Makeflow: A workflow system for parallel and distributed computing that uses
    a language very similar to Make.
  * Work Queue: A system and API for building master-worker style programs that
    scale up to thousands of processors.
  * All Pairs: A computational abstraction for running very large Cartesian
    products.
  * Wavefront: A computational abstraction for running very large dynamic
    programming problems.
  * The Fault Tolerant Shell: A high-level programming language that allows
    users to combine the ease of shell scripting, the power of distributed
    programming, and the precision of compiled languages. Basically,
    parallel programming and exception handling for scripts.

Package: coop-computing-tools-dev
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libraries and header files for coop-computing-tools
 These tools are a collection of software that help users to share resources in
 a complex, heterogeneous, and unreliable computing environment.
 .
 This package provides static libraries and header files for development.

Package: coop-computing-tools-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery
Description: documentation for coop-computing-tools
 These tools are a collection of software that help users to share resources in
 a complex, heterogeneous, and unreliable computing environment.
 .
 This package provides the documentation (manual and API reference) in HTML
 format.

Package: python3-workqueue
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3
Description: cooperative computing tools work queue Python3 bindings
 CCTools's Work Queue is a system and API for building master-worker style
 programs that scale up to thousands of processors. This package provides
 bindings to access this system from Python3.

=== debian/rules ===
#!/usr/bin/make -f

non_default_python3_versions = $(shell python3 -c "print (\"`py3versions -v -s`\".replace(\"`py3versions -v -d`\", '').strip())")

export DH_VERBOSE=1

# one ring to rule them all ...
%:
	dh $@ --with python3

PY3:=$(shell py3versions -d)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) -I /usr/include/$(PY3)

override_dh_auto_configure:
	# disable warning about unused results (necessary because warning is error
	# is ON)
	TWOTOTHREE=/usr/share/doc/python3.8/examples/scripts/2to3 CFLAGS="$(CFLAGS) -DNDEBUG -Wno-unused-result" ./configure --with-globus-path /usr \
		--with-krb5-path /usr --with-readline-path /usr \
		--with-mpi-path /usr --with-fuse-path /usr --with-zlib-path /usr \
		--with-python3-path /usr

override_dh_auto_test:
	# disable the tests for now on upstream's request. they will be reenabled
	# once the test suite can properly deal with the buildd environment

override_dh_auto_install:
	dh_auto_install -- CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp 
	# make extensions for other supported python versions
	if [ -n "$(non_default_python3_versions)" ]; then \
		for pyver in $(non_default_python3_versions); do \
			echo DEBUG $${pyver} ; \
			CFLAGS="$(CFLAGS) -DNDEBUG -Wno-unused-result" TWOTOTHREE=/usr/share/doc/python$${pyver}/examples/scripts/2to3  PYTHON3=/usr/bin/python$${pyver} ./configure.rerun ; \
			make -B -C work_queue/src/python3 install CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp ; \
		done ; \
	fi
	# for now remove the 'apps' scripts till upstream confirms that the language
	# extension can be removed
	rm -f debian/tmp/bin/*.py
	# fix permissions
	find debian/tmp/lib -name '*.py' -exec chmod 644 {} \;
	# remove undesired pieces
	-rm debian/tmp/doc/COPYING
	# upstream says it should not go into the page
	-rm debian/tmp/bin/watchdog
	# HDFS helpers are useless without HDFS in Debian
	-rm debian/tmp/bin/*_hdfs
	# newer doxygen puts jquery copy
	#-rm debian/tmp/doc/api/html/jquery.js
	$(MAKE) doc

override_dh_auto_clean:
	[ -e Makefile.config ] && dh_auto_clean || true
	-rm Makefile.config configure.rerun
	-rm -rf api hdfs-setup.template python/python-workqueue/setup.cfg
	# remove testrun left-overs
	-rm dttools/src/microbench dttools/src/work_queue_example
	-find $(CURDIR) -name '*.test.log' -delete
	-find $(CURDIR) -name '*_test' -delete
	-rm -rf sand/test/filter_verification/random.cand.filter.tmp/
	-rm -rf sand/test/test_20.cand.filter.tmp/
	-rm -f sand/test/test_20.cand sand/test/test_20.cfa sand/test/*.log
	-rm -rf makeflow/test/input/ makeflow/test/worker.pid
	-rm -rf makeflow/test/dirs/testcase.subdir.01.makeflow.makeflowlog
	-rm -rf makeflow/test/dirs/testcase.subdir.01.makeflow.wqlog
	-rm -rf makeflow/test/src/
	-rm dttools/src/multirun sand/test/banded.log
	-rm .configure.tmp.o

## cctools 7.0.22

=== allpairs/Makefile ===
PHONY_TARGETS = src

include ../.module.mk

=== doc/Makefile ===
include ../config.mk

SOURCES=${shell ls man/*.m4}

HTMLFILES = ${SOURCES:%.m4=%.html}
TXTFILES = ${SOURCES:%.m4=%.txt}
PDFFILES = ${SOURCES:%.m4=%.pdf}
MANFILES = ${SOURCES:%.m4=%.1}
ZIPFILES = ${SOURCES:%.m4=%.1.gz}

all: ${CCTOOLS_DOCTARGETS}

htmlpages: ${HTMLFILES}

manpages: ${ZIPFILES}

apiperl: api/html/work_queue_perl.html api/html/work_queue_task_perl.html api/html/chirp_client_perl.html api/html/chirp_stat_perl.html

apipages: api/html/index.html apiperl

api/html/index.html:
	mkdir -p api/html
	doxygen cctools.doxygen.config

api/html/work_queue_perl.html:
	mkdir -p api/html
	pod2html ../work_queue/src/perl/Work_Queue.pm > $@
	@rm -f pod2htm*.tmp

api/html/work_queue_task_perl.html:
	mkdir -p api/html
	pod2html ../work_queue/src/perl/Work_Queue/Task.pm > $@
	@rm -f pod2htm*.tmp

api/html/chirp_client_perl.html:
	mkdir -p api/html
	pod2html ../chirp/src/perl/Chirp/Client.pm > $@
	@rm -f pod2htm*.tmp

api/html/chirp_stat_perl.html:
	mkdir -p api/html
	pod2html ../chirp/src/perl/Chirp/Stat.pm > $@
	@rm -f pod2htm*.tmp

%.html: %.m4
	m4 -DHTML ${CCTOOLS_M4_ARGS} $< > $@

%.1: %.m4
	m4 -DMAN ${CCTOOLS_M4_ARGS} $< > $@

%.txt: %.1
	nroff -man $< > $@

%.gz: %
	gzip < $< > $@

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc/man
	mkdir -p $(CCTOOLS_INSTALL_DIR)/doc/images
	mkdir -p $(CCTOOLS_INSTALL_DIR)/share/man/man1
	cp *.html manual.css $(CCTOOLS_INSTALL_DIR)/doc
	if [ -f man/chirp.html ]; then cp man/*.html $(CCTOOLS_INSTALL_DIR)/doc/man; fi
	if [ -f man/chirp.1.gz ]; then cp man/*.1.gz $(CCTOOLS_INSTALL_DIR)/share/man/man1; fi
	if [ -d api ]; then cp -rp api $(CCTOOLS_INSTALL_DIR)/doc; fi
	if [ -d images ]; then cp images/* $(CCTOOLS_INSTALL_DIR)/doc/images; fi

test:

clean:
	rm -rf api $(HTMLFILES) $(MANFILES) $(ZIPFILES) *~

.PHONY: all clean install test

=== allpairs/src/Makefile ===
include ../../config.mk
include ../../rules.mk

LOCAL_LINKAGE = -lpthread

EXTERNAL_DEPENDENCIES = ../../sand/src/libsandtools.a ../../work_queue/src/libwork_queue.a ../../dttools/src/libdttools.a
OBJECTS = allpairs_compare.o
PROGRAMS = allpairs_multicore allpairs_master
TARGETS = $(PROGRAMS)

all: $(TARGETS)

$(PROGRAMS): $(OBJECTS) $(EXTERNAL_DEPENDENCIES)

clean:
	rm -f $(OBJECTS) $(TARGETS)

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin/

test: all

.PHONY: all clean install test

=== apps/wq_replica_exchange/Makefile ===

include ../../config.mk
include ../../rules.mk

all:

test:

install:
	cp protomol_functions.py ${CCTOOLS_INSTALL_DIR}/bin
	cp replica_exchange.py ${CCTOOLS_INSTALL_DIR}/bin

clean:

=== batch_job/src/Makefile ===
include ../../config.mk
include ../../rules.mk

LIBRARIES = libbatch_job.a

PROGRAMS = work_queue_factory work_queue_pool

ifeq ($(CCTOOLS_CHIRP),chirp)
CHIRP_LIB=../../chirp/src/libchirp.a
CHIRP_BATCH=batch_job_chirp.c
endif

EXTERNAL_LIBRARIES = ../../work_queue/src/libwork_queue.a $(CHIRP_LIB) ../../dttools/src/libdttools.a

SOURCES = \
	batch_file.c \
	batch_task.c \
	batch_wrapper.c \
	batch_job.c \
	batch_job_amazon.c \
	batch_job_amazon_batch.c \
	batch_job_dryrun.c \
	$(CHIRP_BATCH) \
	batch_job_cluster.c \
	batch_job_blue_waters.c \
	batch_job_condor.c \
	batch_job_local.c \
	batch_job_work_queue.c\
	batch_job_lambda.c \
	batch_job_work_queue.c \
	batch_job_mesos.c \
	batch_job_k8s.c \
	mesos_task.c

PUBLIC_HEADERS = batch_job.h

OBJECTS = $(SOURCES:%.c=%.o)

all: $(LIBRARIES) $(PROGRAMS)

libbatch_job.a: $(OBJECTS)

work_queue_factory: work_queue_factory.o libbatch_job.a $(EXTERNAL_LIBRARIES)

# Note that work_queue_pool is the same as work_queue_factory, for backwards compatibility.
work_queue_pool: work_queue_factory
	cp $< $@

install:
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	cp $(PROGRAMS) $(CCTOOLS_INSTALL_DIR)/bin
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
	cp $(LIBRARIES) $(CCTOOLS_INSTALL_DIR)/lib
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(PUBLIC_HEADERS) $(CCTOOLS_INSTALL_DIR)/include/cctools

clean:
	rm -rf $(OBJECTS) $(LIBRARIES) $(PROGRAMS) batch_job_amazon_script.c *.o

=== chirp/src/Makefile ===
--- 
+++ 
@@ -23,9 +23,9 @@
 SOURCES_CONFUGA = confuga.c confuga_namespace.c confuga_replica.c confuga_node.c confuga_job.c confuga_file.c confuga_gc.c
 SOURCES_LIBRARY = chirp_global.c chirp_multi.c chirp_recursive.c chirp_reli.c chirp_client.c chirp_matrix.c chirp_stream.c chirp_ticket.c
 SOURCES_SERVER = sqlite3.c chirp_stats.c chirp_thirdput.c chirp_alloc.c chirp_audit.c chirp_acl.c chirp_group.c chirp_filesystem.c chirp_fs_hdfs.c chirp_fs_local.c chirp_fs_local_scheduler.c chirp_fs_chirp.c chirp_fs_confuga.c chirp_job.c chirp_sqlite.c
-TARGETS = $(PROGRAMS) $(LIBRARIES) bindings
+TARGETS = $(PROGRAMS) $(LIBRARIES)
 
-all: $(TARGETS)
+all: $(TARGETS) bindings
 
 chirp: chirp_tool.o
 ifeq ($(CCTOOLS_STATIC),1)
@@ -57,26 +57,15 @@
 chirp_server: $(OBJECTS_SERVER) libconfuga.a
 $(PROGRAMS_CONFUGA): libconfuga.a libchirp.a $(EXTERNAL_DEPENDENCIES)
 $(PROGRAMS_CHIRP): libchirp.a $(EXTERNAL_DEPENDENCIES)
-$(CCTOOLS_SWIG_BINDINGS): libchirp.a $(EXTERNAL_DEPENDENCIES)
 
-bindings: $(CCTOOLS_SWIG_BINDINGS)
-$(CCTOOLS_SWIG_BINDINGS): chirp_swig_wrap.o
-	@$(MAKE) -C $@
+bindings: chirp_swig_wrap.o libchirp.a libconfuga.a $(EXTERNAL_DEPENDENCIES)
+	@$(MAKE) -C bindings
 
-CCTOOLS_SWIG_BINDINGS_INSTALL = $(CCTOOLS_SWIG_BINDINGS:%=install-%)
-install-bindings: $(CCTOOLS_SWIG_BINDINGS_INSTALL)
-$(CCTOOLS_SWIG_BINDINGS_INSTALL): $(CCTOOLS_SWIG_BINDINGS)
-	@$(MAKE) -C $(@:install-%=%) install
+clean:
+	rm -f $(OBJECTS) $(TARGETS)
+	@$(MAKE) -C bindings clean
 
-CCTOOLS_SWIG_BINDINGS_CLEAN = $(CCTOOLS_SWIG_BINDINGS:%=clean-%)
-clean-bindings: $(CCTOOLS_SWIG_BINDINGS_CLEAN)
-$(CCTOOLS_SWIG_BINDINGS_CLEAN):
-	@$(MAKE) -C $(@:clean-%=%) clean
-
-clean: clean-bindings
-	rm -f $(OBJECTS) $(TARGETS)
-
-install: all install-bindings
+install: all
 	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
 	if [ -f $(CCTOOLS_INSTALL_DIR)/bin/chirp_server ]; then mv $(CCTOOLS_INSTALL_DIR)/bin/chirp_server $(CCTOOLS_INSTALL_DIR)/bin/chirp_server.old; fi
 	chmod 755 $(SCRIPTS)
@@ -87,7 +76,9 @@
 	cp $(PUBLIC_HEADERS) $(CCTOOLS_INSTALL_DIR)/include/cctools/
 	mkdir -p $(CCTOOLS_INSTALL_DIR)/share/cctools/chirp/
 	cp -r ../tools/workflows/ $(CCTOOLS_INSTALL_DIR)/share/cctools/chirp/
+	@$(MAKE) -C bindings install
 
 test: all
+	@$(MAKE) -C bindings test
 
-.PHONY: all clean install test $(CCTOOLS_SWIG_BINDINGS) bindings $(CCTOOLS_SWIG_BINDINGS_INSTALL) install-bindings $(CCTOOLS_SWIG_BINDINGS_CLEAN) clean-bindings
+.PHONY: all clean install test bindings

=== dttools/src/Makefile ===
--- 
+++ 
@@ -66,6 +66,7 @@
 	jx_parse.c \
 	jx_print.c \
 	jx_pretty_print.c \
+	jx_canonicalize.c \
 	jx_table.c \
 	jx_export.c \
 	jx_eval.c \

=== ftsh/test/Makefile ===
include ../../Makefile.config
include ../../Makefile.rules

TESTS = quotes variables loops recurse functions args try forany forall lists expr

all:

test: $(TESTS)

$(TESTS): ../src/ftsh
	@echo "Parsing $@..."
	@../src/ftsh -p $@.ftsh 2>$@.parsed.err > $@.parsed
	@echo "Reparsing $@..."
	@../src/ftsh -p $@.parsed 2>$@.reparsed.err > $@.reparsed
	@echo "Running test $@..."
	@../src/ftsh -l 100 -f $@.log $@.ftsh > $@.out 2> $@.err
	@echo "Checking output of test $@..."
	@diff $@.out $@.expect
	@touch $@
	@echo "Passed."

install:

clean:
	rm -rf *.out *.err *.log *.parsed *.reparsed a g h i $(TESTS)

=== makeflow/src/Makefile ===
include ../../config.mk
include ../../rules.mk

# makeflow must link against globus:
# makeflow -> batch_job -> batch_job_chirp -> auth -> auth_globus -> globus
LOCAL_LINKAGE=$(CCTOOLS_GLOBUS_LDFLAGS)

EXTERNAL_DEPENDENCIES = ../../batch_job/src/libbatch_job.a ../../work_queue/src/libwork_queue.a ../../chirp/src/libchirp.a ../../dttools/src/libdttools.a
OBJECTS = dag.o dag_node_footprint.o dag_node.o dag_file.o dag_variable.o dag_visitors.o dag_resources.o lexer.o parser.o parser_make.o parser_jx.o
PROGRAMS = makeflow makeflow_viz makeflow_analyze makeflow_linker makeflow_status
MAKEFLOW_WRAPPERS = makeflow_wrapper_enforcement.o makeflow_wrapper_umbrella.o makeflow_mounts.o
SCRIPTS = condor_submit_makeflow makeflow_graph_log makeflow_monitor starch makeflow_linker_perl_driver makeflow_linker_python_driver makeflow_archive_query mf_mesos_scheduler mf_mesos_executor mf_mesos_setting makeflow_ec2_setup makeflow_ec2_cleanup makeflow_amazon_batch_setup makeflow_amazon_batch_cleanup makeflow_lambda_setup makeflow_lambda_cleanup
MAKEFLOW_HOOKS = makeflow_hook_example.o
MAKEFLOW_MODULES = \
 makeflow_module_archive.o\
 makeflow_module_docker.o\
 makeflow_module_fail_dir.o\
 makeflow_module_resource_monitor.o\
 makeflow_module_sandbox.o\
 makeflow_module_shared_fs.o\
 makeflow_module_singularity.o\
 makeflow_module_storage_allocation.o\
 makeflow_module_vc3_builder.o\

TARGETS = $(PROGRAMS)

all: $(TARGETS)

makeflow makeflow_viz makeflow_analyze makeflow_status: $(OBJECTS)

makeflow_status: makeflow_status.o

makeflow: makeflow_alloc.o makeflow_summary.o makeflow_gc.o makeflow_log.o makeflow_wrapper.o makeflow_catalog_reporter.o makeflow_local_resources.o $(MAKEFLOW_WRAPPERS) makeflow_hook.o $(MAKEFLOW_HOOKS) $(MAKEFLOW_MODULES)

$(PROGRAMS): $(EXTERNAL_DEPENDENCIES)

lexer_test: dag.o dag_visitors.o makeflow_common.o lexer_test.o $(EXTERNAL_DEPENDENCIES)

lexer_test.o: lexer.c
	$(CCTOOLS_CC) -DLEXER_TEST -o $@ -c $(CCTOOLS_INTERNAL_CCFLAGS) $(LOCAL_CCFLAGS) $<

clean:
	rm -f *.o $(TARGETS) lexer_test*

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	chmod 755 $(SCRIPTS)
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/share/cctools/
	cp style.xml $(CCTOOLS_INSTALL_DIR)/share/cctools/makeflow-cytoscape-style.xml

test: all

.PHONY: all clean install test

=== parrot/src/Makefile ===
include ../../config.mk
include ../../rules.mk

EXTERNAL_DEPENDENCIES = ../../ftp_lite/src/libftp_lite.a ../../chirp/src/libchirp.a ../../grow/src/grow.o ../../dttools/src/libdttools.a
LIBRARIES = libparrot_helper.$(CCTOOLS_DYNAMIC_SUFFIX) libparrot_client.a
OBJECTS = $(OBJECTS_PARROT_RUN) parrot_client.o pfs_resolve_mount.o
OBJECTS_PARROT_RUN = pfs_main.o tracer.o pfs_paranoia.o pfs_dispatch.o pfs_dispatch64.o pfs_process.o pfs_channel.o pfs_sys.o pfs_time.o pfs_table.o pfs_resolve.o pfs_mountfile.o pfs_service.o pfs_file.o pfs_file_cache.o pfs_dir.o pfs_dircache.o pfs_pointer.o pfs_location.o ibox_acl.o pfs_service_local.o pfs_service_http.o pfs_service_grow.o pfs_service_chirp.o pfs_service_multi.o pfs_service_nest.o pfs_service_ftp.o pfs_service_irods.o irods_reli.o pfs_service_hdfs.o pfs_service_bxgrid.o pfs_service_xrootd.o pfs_service_cvmfs.o
PROGRAMS = parrot_run $(UTILITIES)
HEADERS_PUBLIC = parrot_client.h
SCRIPTS = parrot_identity_box parrot_run_hdfs parrot_package_run chroot_package_run
TARGETS = $(PROGRAMS) $(LIBRARIES)
UTILITIES = parrot_lsalloc parrot_mkalloc parrot_getacl parrot_setacl parrot_whoami parrot_locate parrot_md5 parrot_cp parrot_timeout parrot_search parrot_package_create parrot_debug parrot_mount parrot_namespace

ifeq ($(CCTOOLS_BUILD_LIB64PARROT_HELPER),yes)
 LIBRARIES += lib64/libparrot_helper.$(CCTOOLS_DYNAMIC_SUFFIX)
endif

ifeq ($(CCTOOLS_BUILD_LIB32PARROT_HELPER),yes)
 LIBRARIES += lib/libparrot_helper.$(CCTOOLS_DYNAMIC_SUFFIX)
endif

all: $(TARGETS)

$(OBJECTS): tracer.table.h tracer.table.c tracer.table64.h tracer.table64.c

tracer.table.h tracer.table.c tracer.table64.h tracer.table64.c: tracer.table.pl syscall_parrot.tbl

libparrot_client.a: parrot_client.o

libparrot_helper.$(CCTOOLS_DYNAMIC_SUFFIX): parrot_helper.c

lib64/libparrot_helper.$(CCTOOLS_DYNAMIC_SUFFIX): parrot_helper.c
	mkdir -p lib64
	${CCTOOLS_CC} -m64 -shared -fPIC $< -o $@

lib/libparrot_helper.$(CCTOOLS_DYNAMIC_SUFFIX): parrot_helper.c
	mkdir -p lib
	${CCTOOLS_CC} -m32 -shared -fPIC $< -o $@

tracer.table64.c: syscall_64.tbl
	cat $< syscall_parrot.tbl | perl tracer.table.pl table 64 > $@

tracer.table64.h: syscall_64.tbl
	cat $< syscall_parrot.tbl | perl tracer.table.pl header 64 > $@

tracer.table.c: syscall_32.tbl
	cat $< syscall_parrot.tbl | perl tracer.table.pl table 32  > $@

tracer.table.h: syscall_32.tbl
	cat $< syscall_parrot.tbl | perl tracer.table.pl header 32 > $@

parrot_run: $(OBJECTS_PARROT_RUN) libparrot_client.a
	$(CCTOOLS_CXX) -o $@ $(CCTOOLS_INTERNAL_LDFLAGS) $^ $(CCTOOLS_IRODS_LDFLAGS) $(CCTOOLS_MYSQL_LDFLAGS) $(CCTOOLS_XROOTD_LDFLAGS) $(CCTOOLS_CVMFS_LDFLAGS) $(CCTOOLS_GLOBUS_LDFLAGS) $(CCTOOLS_EXTERNAL_LINKAGE)

parrot_cvmfs_static_run: $(OBJECTS_PARROT_RUN) libparrot_client.a $(CCTOOLS_CVMFS_LDFLAGS) $(EXTERNAL_DEPENDENCIES)
	$(CCTOOLS_CXX) -static -static-libstdc++ -static-libgcc -o $@ $^ $(CCTOOLS_INTERNAL_LDFLAGS) -Wl,-Bstatic $(CCTOOLS_EXTERNAL_LINKAGE)

irods_reli.o: irods_reli.cc irods_reli.h
	$(CCTOOLS_CXX) -o $@ -c $(CCTOOLS_INTERNAL_CXXFLAGS) $< $(CCTOOLS_IRODS_CCFLAGS)

pfs_service_bxgrid.o: pfs_service_bxgrid.cc
	$(CCTOOLS_CXX) -o $@ -c $(CCTOOLS_INTERNAL_CXXFLAGS) $< $(CCTOOLS_MYSQL_CCFLAGS)

pfs_service_xrootd.o: pfs_service_xrootd.cc
	$(CCTOOLS_CXX) -o $@ -c $(CCTOOLS_INTERNAL_CXXFLAGS) $< $(CCTOOLS_XROOTD_CCFLAGS)

pfs_service_cvmfs.o: pfs_service_cvmfs.cc
	$(CCTOOLS_CXX) -o $@ -c $(CCTOOLS_INTERNAL_CXXFLAGS) $< $(CCTOOLS_CVMFS_CCFLAGS)

pfs_service_ftp.o: pfs_service_ftp.cc
	$(CCTOOLS_CXX) -o $@ -c $(CCTOOLS_INTERNAL_CXXFLAGS) $< $(CCTOOLS_GLOBUS_CCFLAGS)

$(UTILITIES): libparrot_client.a
parrot_namespace: pfs_mountfile.o pfs_resolve_mount.o

$(PROGRAMS): $(EXTERNAL_DEPENDENCIES)

clean:
	rm -f $(OBJECTS) $(TARGETS) $(PROGRAMS) $(LIBRARIES) tracer.table.c tracer.table.h tracer.table64.c tracer.table64.h

install: all
	mkdir -p $(CCTOOLS_INSTALL_DIR)/bin
	chmod 755 $(SCRIPTS)
	cp $(PROGRAMS) $(SCRIPTS) $(CCTOOLS_INSTALL_DIR)/bin/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/include/cctools
	cp $(HEADERS_PUBLIC) $(CCTOOLS_INSTALL_DIR)/include/cctools/
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib
ifeq ($(CCTOOLS_BUILD_LIB64PARROT_HELPER),yes)
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib/lib64
endif
ifeq ($(CCTOOLS_BUILD_LIB32PARROT_HELPER),yes)
	mkdir -p $(CCTOOLS_INSTALL_DIR)/lib/lib
endif
	for lib in $(LIBRARIES); do cp $$lib $(CCTOOLS_INSTALL_DIR)/lib/$$lib; done

test: all

.PHONY: all clean install test

=== resource_monitor/src/Makefile ===
--- 
+++ 
@@ -21,13 +21,8 @@
 
 all: $(TARGETS) bindings
 
-# Note below: we use gcc on static builds so that the library gets to use the system linker.
 librmonitor_helper.$(CCTOOLS_DYNAMIC_SUFFIX): rmonitor_helper.o rmonitor_helper_comm.o
-ifeq ($(CCTOOLS_STATIC),1)
-	gcc           -shared -Wl,-init,rmonitor_helper_initialize -fPIC $^ -o $@ -ldl $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LINKAGE) $(CCTOOLS_EXTERNAL_LINKAGE)
-else
 	$(CCTOOLS_CC) -shared -Wl,-init,rmonitor_helper_initialize -fPIC $^ -o $@ -ldl $(CCTOOLS_INTERNAL_LDFLAGS) $(LOCAL_LINKAGE) $(CCTOOLS_EXTERNAL_LINKAGE)
-endif
 
 piggybacker: piggybacker.o

=== s3tools/src/Makefile ===
include ../../config.mk
include ../../rules.mk

EXTERNAL_DEPENDENCIES = ../../dttools/src/libdttools.a
LIBRARIES = libs3client.a
OBJECTS = $(SOURCES:%.c=%.o)
PROGRAMS = s3put s3get s3stat s3rm s3mkdir s3rmdir s3ls s3getacl s3setacl
SOURCES = s3c_file.c s3c_acl.c s3c_bucket.c s3c_util.c
TARGETS = $(LIBRARIES) $(PROGRAMS)

all: $(TARGETS)

libs3client.a: $(OBJECTS)
$(PROGRAMS): s3common.o $(LIBRARIES) $(EXTERNAL_DEPENDENCIES)

clean:
	rm -f $(OBJECTS) $(TARGETS)

install: all

test: all

.PHONY: all clean install test

=== debian/changelog ===
cctools (7.0.22-1ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Fix build by using -O0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Mar 2020 18:32:02 +0100

cctools (7.0.22-1) unstable; urgency=medium

  * New upstream release
  * Use dh-sequence-python3 instead of --with python3
  * Standards-Version: 4.5.0
  * Update patch python3.path -> python-paths.patch 

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 16 Mar 2020 14:38:55 +0000

cctools (7.0.9-5ubuntu1) focal; urgency=medium

  * Fix build by using -O0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 22 Jan 2020 16:20:22 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 12), 
-  dh-python,
+  dh-sequence-python3,
   python3-all-dev, 
   python3.8-examples,
   libglobus-common-dev,
@@ -19,7 +19,7 @@
   swig,
   m4, 
   mpi-default-dev
-Standards-Version: 4.4.1.0
+Standards-Version: 4.5.0
 Homepage: https://ccl.cse.nd.edu/software/
 Vcs-Browser: https://salsa.debian.org:/neurodebian-team/cctools.git
 Vcs-Git: https://salsa.debian.org:/neurodebian-team/cctools.git

=== debian/rules ===
--- 
+++ 
@@ -6,10 +6,10 @@
 
 # one ring to rule them all ...
 %:
-	dh $@ --with python3
+	dh $@ 
 
 PY3:=$(shell py3versions -d)
-CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) -I /usr/include/$(PY3)
+CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) -I /usr/include/$(PY3) -O0
 
 override_dh_auto_configure:
 	# disable warning about unused results (necessary because warning is error
@@ -29,8 +29,8 @@
 	if [ -n "$(non_default_python3_versions)" ]; then \
 		for pyver in $(non_default_python3_versions); do \
 			echo DEBUG $${pyver} ; \
-			CFLAGS="$(CFLAGS) -DNDEBUG -Wno-unused-result" TWOTOTHREE=/usr/share/doc/python$${pyver}/examples/scripts/2to3  PYTHON3=/usr/bin/python$${pyver} ./configure.rerun ; \
-			make -B -C work_queue/src/python3 install CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp ; \
+			CFLAGS="$(CFLAGS) -DNDEBUG -Wno-unused-result" TWOTOTHREE=/usr/share/doc/python3.8/examples/scripts/2to3  PYTHON3=/usr/bin/python$${pyver} ./configure.rerun ; \
+			make -B -C work_queue/src/bindings/python3 install CCTOOLS_INSTALL_DIR=$(CURDIR)/debian/tmp ; \
 		done ; \
 	fi
 	# for now remove the 'apps' scripts till upstream confirms that the language
